# Copyright (c) 2012 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with this program. If not, see
# <http://www.gnu.org/licenses/>.

__metaclass__ = type

import fixtures

from grackle.server.testing.cassandra import TemporaryDB
from grackle.server.model import CassandraConnection


TEST_MESSAGE = """\
From: sysadmin@example.com
To: developer@example.com
Subject: Everything is broken
Date: Sat, 1 Jan 2000 11:02:34 +1100
Message-Id: <aaaaaaaaaaaaa@example.com>

Help, everything has just broken.
"""


class TestModel(fixtures.TestWithFixtures):

    def test_add_message(self):
        keyspace = self.useFixture(TemporaryDB()).keyspace
        c = CassandraConnection(keyspace, ['localhost:9160'])
        c.add_message('foo', TEST_MESSAGE)


class TestModel(fixtures.TestWithFixtures):

    def test_add_message(self):
        keyspace = self.useFixture(TemporaryDB()).keyspace
        c = CassandraConnection(keyspace, ['localhost:9160'])
        key = c.add_message('foo', TEST_MESSAGE)
        cmsg = c.messages.get(key)
        self.assertEqual(TEST_MESSAGE, cmsg['content'])
        self.assertEqual('sysadmin@example.com', cmsg['from'])
        self.assertEqual('developer@example.com', cmsg['to'])
        self.assertEqual('Everything is broken', cmsg['subject'])
        self.assertEqual('2000-01-01T11:02:34+11:00', cmsg['date'])
        self.assertEqual('<aaaaaaaaaaaaa@example.com>', cmsg['message_id'])
